/*
###PARA COMPILAR O CÓDIGO USE A LINHA DE COMANDO ABAIXO###
gcc arduinoat89s52.c -o arduinoat89s52.out $(mysql_config --include --libs) -Wall
        /\                      /\
        ||                      ||
        ||               nome do arquivo na saida
        ||

nome do arquido de entrada  
*/

#include <mysql.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>

int main() {


    /* VARIÁVEIS DB */
    MYSQL* conexao = mysql_init(NULL);//inicializa a conexão
    char DBHOST[] = "localhost";
    char DBNAME[] = "lt38c";
    char DBUSER[] = "root";
    char DBPASS[] = "mysqllt38c";

    char DBQUERY[] = "SELECT id, firmware, sync, md5sum FROM arduino WHERE sync='1';";


    long int id;
    char firmware[65536];
    int sync;
    char md5sum[33];

    /* VARIÁVEIS DE COMANDO E DE NOTIFICAÇÃO */

    //comandos
    char comandBurner[] = "avrdude -c arduino -p m328p -P /dev/ttyACM0 -b 115200 -D -U /tmp/hexfile.hex 2>&1 | tee /tmp/tmpBurnerMicro.log";
    //caso o micro seja o at89s52 , necessário desabilitar o de cima e habilitar o de baixo
    //char comandBurner[] = "avrdude -c arduino -p m328p -P /dev/ttyACM0 -b 115200 -D -U /tmp/hexfile.hex 2>&1 | tee /tmp/tmpBurnerMicro.log";

    //mensagens
    char msgIniciaSistema[] = "### Iniciando o sistema ###\n";
    char msgFalhaConexaoMysql[] = "### FALHA NA COMUNICAÇÃO COM O MYSQL ###\n";
    char msgFalhaResMysql[] = "###FALHA NO RESULTADO DO MYSQL_RES### \n";
    char msgGravacaoSucesso[] = "### microcontroaldor gravado com sucesso ### \n";
    char msgSyncSucesso[] = "### linha sincronizada com sucesso no banco e atualizado o SYNC ### \n";
    char msgGravacaoErro[] = "### Não foi possivel gravar. Provavelmente há algum problema com o microcontroaldor ou ele não está conectado corretamente ### \n";
    char msgMD5Error[] = "### Md5 nao coincide ###\n";


    FILE *fpLog; //necessário para a criação do log 
    fpLog = fopen("arduinoat89s52.log", "a+");

    /* FIM VARIÁVEIS DE COMANDO E NOTIFICAÇÃO */
    
    fputs(msgIniciaSistema, fpLog);

    mysql_real_connect(conexao, DBHOST, DBUSER, DBPASS, DBNAME, 0, NULL, 0);
    
    if (!conexao) {

        printf(msgFalhaConexaoMysql);
        fputs(msgFalhaConexaoMysql, fpLog);

        return 1;
    }
    
    fclose(fpLog) ;


    while (1) {

        fpLog = fopen("arduinoat89s52.log", "a+");

        char* query = DBQUERY;  
        int tamanho = strlen(query);                                                  

        mysql_real_query(conexao, query, tamanho);
        MYSQL_RES* result = mysql_store_result(conexao);                                   
        if (!result) {

            fputs(msgFalhaResMysql, fpLog);
            return 1;
        }
        
        MYSQL_ROW rows;


        while ((rows = mysql_fetch_row(result))) {    // busca uma linha dentro de result

            id = atoi(rows[0]);
            strcpy(firmware, rows[1]);
            sync = atoi(rows[2]);
            strcpy(md5sum, rows[3]);

            /*
            printf("###Há linhas com sync = 1 ###");
            fputs("###Há linhas com sync = 1 ###\n", fpLog);
            */

            if (sync == 1) {

                sync = 0; //


               //printf(" ### ENTROU NO SYNC ### ");

                FILE* fp;     // Salva o arquivo recebido do BD
                fp = fopen("/tmp/hexfile.hex", "w");
                fprintf(fp, firmware);
                fclose(fp);

                // validação do arquivo
                fp = fopen("/tmp/hexfile.md5", "w");
                fprintf(fp, "%s  /tmp/hexfile.hex", md5sum);
                fclose(fp);

                int md5ret = system("md5sum --check /tmp/hexfile.md5 --status"); //retorna 0 se arquivo ok
                int md5status = WEXITSTATUS(md5ret);

                if (md5status == 0) {

                    const char* avrdude_upload = comandBurner;
                    int avrduderet = system(avrdude_upload);
                    int avrdudestatus = WEXITSTATUS(avrduderet);

                    if (avrdudestatus != 0) {

                     break;
                 }else{

                    //continua aqui a verificação


                    if(buscarNoArquivo("/tmp/tmpBurnerMicro.log", "flash verified")){


                        //coloca o SYNC como 0
                        char buffer[100];
                        sprintf(buffer, "UPDATE arduino SET sync='0' WHERE id='%d'", id);
                        //printf("%s", buffer);

                        query = buffer;
                        tamanho = strlen(query);
                        mysql_real_query(conexao, query, tamanho);

                        fputs(msgSyncSucesso, fpLog);
                        fputs(msgGravacaoSucesso, fpLog);

                        //sync = 0;
                        //printf("id=%s sincronizado!\n", id);

                        break;

                    }else{

                        fputs(msgGravacaoErro, fpLog);
                        break;
                    }

                }


            }else {


                // hash do BD nao coincide com hash do firmware baixado
                fputs(msgMD5Error, fpLog);

		        //ATUALIZA SYNC
                char buffer[100];
                sprintf(buffer, "UPDATE arduino SET sync='2' WHERE id='%d'", id);
                query = buffer;
                tamanho = strlen(query);
                mysql_real_query(conexao, query, tamanho);
                printf("id=%d sincronizado!\n", id);
                break;
            }



         //   sleep(geradorNumeroFloat(0.1, 0.5));

        }
    }

    mysql_free_result(result);

    fclose(fpLog) ;
}

//fclose(fpLog) ;
return 0;
}


//Função para Buscar string dentro de um arquivo
int buscarNoArquivo(char *fname, char *str) {
    FILE *fp;
    int line_num = 1;
    int find_result = 0;
    char temp[60000];

    //gcc users
    
    if((fp = fopen(fname, "r")) == NULL) {
      return(-1);
  }

  while(fgets(temp, 60000, fp) != NULL) {
    if((strstr(temp, str)) != NULL) {
        printf("A match found on line: %d\n", line_num);
        printf("\n%s\n", temp);
        find_result++;
    }
    line_num++;
}

if(fp) { fclose(fp);}

if(find_result > 0) {

    return(1);

}else{

    return(0);

}

}